<ng-container *ngIf="vm$ | async as vm">
  <div [ngClass]="[jds.tablePaging]">
    <div [ngClass]="[jds.tableResponsive]">
      <table
        [ngClass]="[jds.table, jds.mb(0)]"
        role="table"
        aria-label="List Notification"
        aria-describedby="Table List Notification"
      >
        <thead>
          <tr>
            <th
              [style.width.%]="14"
              [colorScheme]="'gray'"
              [colorCustom]="true"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              scope="col"
              jdsBiTableHead
              column="cdate"
            >
              Waktu/Tanggal
            </th>
            <th>Judul</th>
            <th
              *ngIf="vm.filterType === 'upload-change'"
              [style.width.%]="10"
              [colorScheme]="'gray'"
              [colorCustom]="true"
              [isFilterable]="true"
              scope="col"
              jdsBiTableHead
              column="type"
            >
              <span>Tipe Data</span>

              <div
                [style.cursor]="'pointer'"
                filter
                role="button"
              >
                <jds-bi-hosted-dropdown
                  [(open)]="isOpenTypeData"
                  [jdsBiDropdownLimitWidth]="'custom'"
                  [jdsBiDropdownMinWidth]="240"
                  [content]="dropdownTypeData"
                >
                  <i
                    class="tblhd-icon"
                    [ngClass]="['active']"
                  ></i>
                </jds-bi-hosted-dropdown>
              </div>
            </th>
            <th
              [ngClass]="[jds.textAlign('center')]"
              [style.width.%]="10"
              scope="row"
            >
              Aksi
            </th>
          </tr>
        </thead>
        <tbody>
          <ng-container *ngIf="vm.listNotification as listNotification">
            <ng-container *ngIf="listNotification.status === 'loading'">
              <ng-container *ngTemplateOutlet="loading" />
            </ng-container>

            <ng-container *ngIf="listNotification.status === 'success'">
              <ng-container *ngIf="listNotification.isFetching">
                <ng-container *ngTemplateOutlet="loading" />
              </ng-container>

              <ng-container *ngIf="!listNotification.isFetching">
                <ng-container *ngIf="listNotification.data.list.length > 0">
                  <tr *ngFor="let item of listNotification.data.list">
                    <td>
                      {{ moment(item.mdate).format('HH:mm DD/MM/YYYY') }}
                    </td>
                    <td>
                      <ng-container [ngSwitch]="item.feature">
                        <!-- Upload Change -->
                        <ng-container *ngSwitchCase="2">
                          <span [innerHTML]="item.title"></span>
                          <span [innerHTML]="item.content"></span>
                        </ng-container>

                        <!-- Request Dataset Satu Data -->
                        <ng-container *ngSwitchCase="3">
                          <span
                            [innerHTML]="
                              getRequestDatasetPrivateContent(
                                item.title,
                                item.content
                              )
                            "
                          ></span>
                        </ng-container>

                        <!-- Request Dataset Open Data -->
                        <ng-container *ngSwitchCase="4">
                          <div
                            [innerHTML]="item.title + ' ' + item.content"
                          ></div>
                        </ng-container>

                        <!-- E-Walidata -->
                        <ng-container *ngSwitchCase="5">
                          <span [innerHTML]="item.title"></span>
                          <span [innerHTML]="item.content"></span>
                        </ng-container>
                      </ng-container>
                    </td>
                    <td *ngIf="vm.filterType === 'upload-change'">
                      <span
                        *ngIf="item.type === 'dataset'"
                        [colorScheme]="'purple'"
                        [variant]="'subtle'"
                        [isRounded]="true"
                        jdsBiBadge
                      >
                        Dataset
                      </span>
                      <span
                        *ngIf="item.type === 'mapset'"
                        [colorScheme]="'red'"
                        [variant]="'subtle'"
                        [isRounded]="true"
                        jdsBiBadge
                      >
                        Mapset
                      </span>
                    </td>
                    <td [ngClass]="[jds.textAlign('center')]">
                      <div
                        [ngClass]="[jds.d('grid')]"
                        [style.gap.px]="4"
                      >
                        <ng-container [ngSwitch]="item.feature">
                          <!-- Upload Change -->
                          <ng-container *ngSwitchCase="2">
                            <button
                              [disabled]="item.is_enable === false"
                              [colorScheme]="'green'"
                              (click)="
                                onRead(
                                  item.feature,
                                  item.type,
                                  item.type_id,
                                  item.title,
                                  item.notes
                                )
                              "
                              jdsBiButton
                            >
                              Lihat
                            </button>
                          </ng-container>

                          <!-- Request Dataset Satu Data -->
                          <ng-container *ngSwitchCase="3">
                            <ng-container
                              *ngIf="satudataUser.role_name === 'walidata'"
                            >
                              <button
                                [disabled]="item.is_enable === false"
                                [colorScheme]="'green'"
                                (click)="
                                  onRequestDatasetPrivate(
                                    item.type,
                                    item.type_id
                                  )
                                "
                                jdsBiButton
                              >
                                Lihat
                              </button>
                            </ng-container>
                            <ng-container
                              *ngIf="
                                satudataUser.role_name === 'opd' ||
                                satudataUser.role_name === 'opd-view'
                              "
                            >
                              <button
                                [ngClass]="[jds.button, jds.buttonPrimary]"
                                [colorScheme]="'blue'"
                                (click)="
                                  onRequestDatasetPrivate(
                                    item.type,
                                    item.type_id
                                  )
                                "
                                jdsBiButton
                              >
                                Lacak
                              </button>
                            </ng-container>
                          </ng-container>

                          <!-- Request Dataset Open Data -->
                          <ng-container *ngSwitchCase="4">
                            <button
                              [disabled]="item.is_enable === false"
                              [colorScheme]="'green'"
                              (click)="
                                onRead(item.feature, item.type, item.type_id)
                              "
                              jdsBiButton
                            >
                              Lihat
                            </button>
                          </ng-container>

                          <!-- E-Walidata -->
                          <ng-container *ngSwitchCase="5">
                            <button
                              [disabled]="item.is_enable === false"
                              [colorScheme]="'green'"
                              (click)="
                                onRead(item.feature, item.type, item.type_id)
                              "
                              jdsBiButton
                            >
                              Lihat
                            </button>
                          </ng-container>
                        </ng-container>
                      </div>
                    </td>
                  </tr>
                </ng-container>

                <ng-container *ngIf="listNotification.data.list.length === 0">
                  <ng-container *ngTemplateOutlet="empty" />
                </ng-container>
              </ng-container>
            </ng-container>
          </ng-container>
        </tbody>
      </table>
    </div>

    <ng-container *ngIf="vm.listNotification as listNotification">
      <ng-container *ngIf="listNotification.status === 'success'">
        <ng-container *ngIf="listNotification.data.list.length > 0">
          <jds-bi-pagination
            [colorScheme]="colorScheme"
            [perPageItems]="perPageItems"
            [pagination]="listNotification.data.pagination"
            [perPage]="vm.filterPerPage"
            [page]="vm.filterCurrentPage"
            (filterPerPage)="onPerPage($event)"
            (filterPage)="onPage($event)"
          />
        </ng-container>
      </ng-container>
    </ng-container>
  </div>

  <app-modal-request-satudata-tracking
    [feature]="'notification'"
    [notificationData]="vm.detailNotification"
    [historyData]="vm.historyRequestDatasetSatuData"
  />

  <ng-template #dropdownTypeData>
    <div [ngClass]="[jds.px(16), jds.pt(12), jds.pb(8)]">
      <ul
        [ngClass]="[jds.ps(0), jds.mb(0)]"
        [style.listStyle]="'none'"
        [style.height]="'auto'"
      >
        <li
          *ngFor="let type of typeOptions"
          [ngClass]="[jds.mb(5), jds.pe(15)]"
        >
          <div [ngClass]="[jds.formCheck]">
            <input
              id="checkbox-type-{{ type.value }}"
              [(ngModel)]="type.checked"
              [ngClass]="[jds.formCheckInput]"
              (change)="onFilter(type.value, $event.target.checked)"
              type="checkbox"
            />
            <label
              [ngClass]="[jds.formCheckLabel]"
              for="checkbox-type-{{ type.value }}"
            >
              {{ type.label }}
            </label>
          </div>
        </li>
      </ul>
    </div>
  </ng-template>

  <ng-template #loading>
    <tr *ngFor="let i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]">
      <ng-container [ngSwitch]="vm.filterType">
        <ng-container *ngSwitchCase="'upload-change'">
          <td *ngFor="let j of getSkeleton().uploadChange">
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
        </ng-container>
        <ng-container *ngSwitchCase="'request-dataset'">
          <td *ngFor="let j of getSkeleton().requestDataset">
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
        </ng-container>
        <ng-container *ngSwitchCase="'e-walidata'">
          <td *ngFor="let j of getSkeleton().eWalidata">
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
        </ng-container>
      </ng-container>
    </tr>
  </ng-template>

  <ng-template #skeleton>
    <div class="wrapper-skeleton">
      <ngx-skeleton-loader
        [theme]="{
          width: '80%',
          'border-radius': '0',
          height: '22px',
          'margin-bottom': '0px'
        }"
      />
    </div>
  </ng-template>

  <ng-template #empty>
    <tr>
      <ng-container [ngSwitch]="vm.filterType">
        <ng-container *ngSwitchCase="'upload-change'">
          <td
            [attr.colspan]="getSkeleton().uploadChange.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        </ng-container>
        <ng-container *ngSwitchCase="'request-dataset'">
          <td
            [attr.colspan]="getSkeleton().requestDataset.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        </ng-container>
        <ng-container *ngSwitchCase="'e-walidata'">
          <td
            [attr.colspan]="getSkeleton().eWalidata.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        </ng-container>
      </ng-container>
    </tr>
  </ng-template>
</ng-container>
